package org.expeditee.io;

import java.io.IOException;
import java.io.Writer;
import java.util.List;

import org.expeditee.gui.Frame;
import org.expeditee.items.Item;
import org.expeditee.items.Picture;
import org.expeditee.items.Text;

public class JAVAWriter extends DefaultTreeWriter {

	private int _indent = 0;

	private static final String INDENT = "   ";

	@Override
	protected void initialise(Frame start, Writer writer) throws IOException {
		_format = ".java";
		super.initialise(start, writer);

		// write the package and import statements here!!
	}

	@Override
	protected String finaliseTree() throws IOException {
		_writer.write("}" + ItemWriter.NEW_LINE);
		return super.finaliseTree();
	}

	@Override
	protected void writeStartLink(Item linker) throws IOException {
		indent();
		_writer.write("{" + ItemWriter.NEW_LINE);
		_indent++;
	}

	@Override
	protected void writeEndLink(Item linker) throws IOException {
		_indent--;
		indent();
		_writer.write("}" + ItemWriter.NEW_LINE);
	}

	@Override
	protected void writeTitle(Text toWrite, List<Item> items)
			throws IOException {
		String heading = toWrite.getText();

		_writer.write("public class " + heading + "{" + ItemWriter.NEW_LINE);
	}

	@Override
	protected void writeText(Text text) throws IOException {
		indent();
		_writer.write(text.getText().replace('\n', ' '));
		_writer.write(";" + ItemWriter.NEW_LINE);
	}

	private void indent() throws IOException {
		for (int i = 0; i < _indent; i++)
			_writer.write(INDENT);
	}

	@Override
	protected void writePicture(Picture pic) throws IOException {
	}
}
